
import re
import pymongo
import os
def find_different_sentences(text, string, i):
    foundMatches = 0
    complusoryMatch = 0
    for s in string:
        if not re.search(s, text):
            1
        else:
            if s =='unconsolidated statement of financial position':
                complusoryMatch = complusoryMatch +1
            else:
                foundMatches=foundMatches +1
            
    if complusoryMatch>0 and foundMatches >3:
        return True
    if complusoryMatch ==0:
        return False

    return False



def create_db(myclient):
    dblist = myclient.list_database_names()
    if "fintechdb" in dblist:
        print("The database exists.")
    else:
        mydb = myclient['fintechdb']
        print("DB created by the name of fintechdb")
 

def check_for_company_annual_in_db(company,file,completePath,myclient):
    print("check for company annual in db")
    mydb = myclient["fintechdb"]
    myquery = { "name": company }
    mycol = mydb["companies"]
    mydoc = mycol.find(myquery)
    print(file)
    for x in mydoc:
        if x.get("annual_reports") is not None:
            annualReports = x.get('annual_reports')
            if file not in annualReports:
                newvalues = { "$push": { "annual_reports": file } }
                mycol.update_one(myquery, newvalues)
                
            print("Exists")
        else:
            newvalues = { "$set": { "annual_reports": [file] } }
            mycol.update_one(myquery, newvalues)
            print("Doesn't exist")
            


def check_for_company_quarterly_in_db(company,file,completePath,myclient):
    print("check for company quarterly in db")
    mydb = myclient["fintechdb"]
    myquery = { "name": company }
    mycol = mydb["companies"]
    mydoc = mycol.find(myquery)
    print(file)
    for x in mydoc:
        if x.get("quarterly_reports") is not None:
            quarterlyReports = x.get('quarterly_reports')
            if file not in quarterlyReports:
                newvalues = { "$push": { "quarterly_reports": file } }
                mycol.update_one(myquery, newvalues)
                
            print("Exists")
        else:
            newvalues = { "$set": { "quarterly_reports": [file] } }
            mycol.update_one(myquery, newvalues)
            print("Doesn't exist")

    
def check_for_annual_reports(comp):
    rootdir="financialreports/"+comp+"/annual/"
    for file in os.listdir(rootdir):
        d = os.path.join(rootdir, file)
        if os.path.isfile(d):
            #check if company already exists if it doesn't create one in the DB
            check_for_company_annual_in_db(comp,file,d)
    
    
def check_for_quarterly_reports(comp):
    rootdir="financialreports/"+comp+"/quarterly/"
    for file in os.listdir(rootdir):
        d = os.path.join(rootdir, file)
        if os.path.isfile(d):
            #check if company already exists if it doesn't create one in the DB
            check_for_company_quarterly_in_db(comp,file,d)
            
            
def check_for_company_in_db(file,myclient):
    mydb = myclient["fintechdb"]
    collist = mydb.list_collection_names()
    if "companies" in collist:
        print("collection exists")
    else:
        mycol = mydb["companies"]
        print("Didn't exist create from scratch")
    mycol = mydb["companies"]
    myquery = { "name": file }
    getRecord =len(list(mycol.find(myquery)))
    if getRecord==0:
        mydict ={"name":file}
        mycol.insert_one(mydict)
        check_for_annual_reports(file)
        check_for_quarterly_reports(file)
    else:
        check_for_annual_reports(file)
        check_for_quarterly_reports(file)

 #give rootdir   
def get_company_names_and_discover(rootdir):
    for file in os.listdir(rootdir):
        d = os.path.join(rootdir, file)
        if os.path.isdir(d):
            #check if company already exists if it doesn't create one in the DB
            check_for_company_in_db(file)